/*! 
*   @file readIC.c AD22100 measurement code header file
*   @author Adam Mendrela, Andrew Kerns
*/

#include "readIC.h"

float xfloat;
//#ifdef DEBUG
	char v_string[9];
	char g_string[9];
//#endif
uint16_t x, AinHigh, AinLow;

inline void set_Ain_A0 ()
{
	ADMUX &=  ~(1<<MUX0);
}

inline void set_Ain_A1 ()
{
	ADMUX |=  (1<<MUX0);
}

float readIC()
{
	//fprintf(stdout,"DDRA=%u,PORTA=%u\n\r",(uint16_t)DDRA,(uint16_t)PORTA);
	//fprintf(stdout,"ADMUX = %u\n\r",(uint16_t)ADMUX);
   	AinLow = (uint16_t)(ADCL >> 6);
   	AinHigh = ((uint16_t)ADCH) << 2; 
   	x = AinHigh + AinLow;
	
	ADCSRA |= (1<<ADSC); //start another conversion
	
	//#if DEBUG
		//fprintf(stdout, "IC: A1 = %u LSBs,L=%u,H=%u\n\r", x, AinLow, AinHigh);
	//#endif
	
	xfloat = (5.0*(float)x)/1023.0;
	//#if DEBUG
		//dtostrf(xfloat, 6, 3, v_string);
		//fprintf(stdout, "x = %u, %s V \n\r",x, v_string);
	//#endif

	return (xfloat-1.375)*44.444;  // 30 = 150degC / 5V
}

void initIC()
{
	
	
	DDRA =  0x00; // reset to all input
	PORTA = 0x00; //   and no pull ups
	//fprintf(stdout,"IC initialized \n\r");
	//set up ADC
	ADMUX = _BV(ADLAR) | _BV(REFS0);
	_delay_ms(TIME_REFSETTLE_MS);
	
	set_Ain_A1();
	
	ADCSRA |= ((1<<ADEN) | (1<<ADSC)) + 7; 
}
