/*! 
*   @file readNTC.h NTC thermistor measurement code header file
*   @author Adam Mendrela, Andrew Kerns
*/

#ifndef __READNTC_H_GUARD_
#define __READNTC_H_GUARD_

#include "cook.h"
#include <avr/io.h>
#include <util/delay.h>
#include <math.h>

//Adjust resistors to the ones used
#define NTC_MODE1_RES 100200.0
#define NTC_MODE2_RES 18170.0
#define NTC_MODE3_RES 5230.0
#define NTC_MODE4_RES 1970.0
#define NTC_MODE5_RES 990.0  //changed

#define NTC_FEEDBACK_RES 19700.0
#define NTC_MODE1_GAIN	(1 + NTC_FEEDBACK_RES/NTC_MODE1_RES)
#define NTC_MODE2_GAIN	(1 + NTC_FEEDBACK_RES/NTC_MODE2_RES)
#define NTC_MODE3_GAIN	(1 + NTC_FEEDBACK_RES/NTC_MODE3_RES)
#define NTC_MODE4_GAIN	(1 + NTC_FEEDBACK_RES/NTC_MODE4_RES)
#define NTC_MODE5_GAIN	(1 + NTC_FEEDBACK_RES/NTC_MODE5_RES)

//#define LSB_TO_TDEGC_HIGHR   
#define B 3450
#define RS 5040
#define LOG_R0 9.2103
#define B_BY_T0 (3450.0/298.15)
#define TIME_REFSETTLE_MS 4

float readNTC(void);
void initNTC(void);

#endif
