/*! 
*   @file userinterface.h keypad and LCD management header file
*   @author Adam Mendrela, Andrew Kerns
*/

#ifndef __USERINTERFACE_H_GUARD_
#define __USERINTERFACE_H_GUARD_

#include "cook.h"

// define debouncer states
#define DB_REL 		0
#define DB_MPRESS 	1
#define DB_PRESS	2
#define DB_MREL		3

#define MAXKEYS 16

// define keypad mapping
#define KEY_STAR 	13
#define KEY_A 		4
#define KEY_B 		8
#define KEY_C 		12
#define KEY_D 		16
#define KEY_1 		1
#define KEY_2 		2
#define KEY_3 		3
#define KEY_4 		5
#define KEY_5 		6
#define KEY_6 		7
#define KEY_7 		9
#define KEY_8 		10
#define KEY_9 		11
#define KEY_0 		14
#define KEY_POUND  	15

#define PARAM_NUMDIGITS	3

#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include "lcd_lib.h"

uint8_t updateDB(uint8_t);
uint8_t scanKeypad(void);
void updateState(uint8_t);

void initLCD(void);
void updateLCD(void);

#endif // guard endif
